Bug 2278422 - Review Request: python-nbdime - Diff and merge of Jupyter notebooks
Summary: Review Request: python-nbdime - Diff and merge of Jupyter notebooks
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: wojnilowicz
QA Contact: Fedora Extras Quality Assurance
URL: https://nbdime.readthedocs.io/
Whiteboard:
Depends On: 2278421
Blocks: 2278423
TreeView+ depends on / blocked
 
Reported: 2024-05-01 20:25 UTC by Jerry James
Modified: 2024-06-29 01:35 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2024-06-29 01:35:23 UTC
Type: ---
Embargoed:
lukasz.wojnilowicz: fedora-review+


Attachments (Terms of Use)

Description Jerry James 2024-05-01 20:25:50 UTC
Spec URL: https://jjames.fedorapeople.org/python-nbdime/python-nbdime.spec
SRPM URL: https://jjames.fedorapeople.org/python-nbdime/python-nbdime-4.0.1-1.fc41.src.rpm
Fedora Account System Username: jjames
Description: Nbdime provides tools for diffing and merging of Jupyter notebooks.
- nbdiff: compare notebooks in a terminal-friendly way
- nbmerge: three-way merge of notebooks with automatic conflict resolution
- nbdiff-web: shows you a rich rendered diff of notebooks
- nbmerge-web: gives you a web-based three-way merge tool for notebooks
- nbshow: present a single notebook in a terminal-friendly way

Note that this package can only be built for x86_64 and aarch64.  It uses nx to build, and requires a binary nx package, which is only available for those 2 architectures.  If someone knows how to get around that restriction, I would be very happy if you would tell me.

See https://copr.fedorainfracloud.org/coprs/jjames/Jupyter/ for builds of this package.

I am willing to swap reviews.

Comment 1 Fedora Review Service 2024-05-01 20:30:24 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7397094
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2278422-python-nbdime/fedora-rawhide-x86_64/07397094-python-nbdime/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 wojnilowicz 2024-05-17 19:03:36 UTC
It looks a bit scary :)

Before I look into it deeper:
1) Previous post from Fedora Review Service says it doesn't build. Could you fix that?
2) Could you use 
https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-jupytext.spec#_52
https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-jupytext.spec#_144
instead of
"# Move the configuration files to where we want them"?
3) Is %{_bindir}/nbdime not missing a man page?

Comment 3 wojnilowicz 2024-05-18 15:49:40 UTC
Once again a full list of my remarks:
1) Previous post from Fedora Review Service says it doesn't build. Could you fix that? I'm not sure if that's related, but it asked me three times about various missing dependencies when I tried to build it myself.

2) Could you use 
https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-jupytext.spec#_52
https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-jupytext.spec#_144
instead of
"# Move the configuration files to where we want them"?

3) rpmlint reported python3-nbdime.noarch: W: no-manual-page-for-binary nbdime. Could you fix that?

4) rpmlint reported python3-nbdime.noarch: W: files-duplicate /usr/lib/python3.12/site-packages/nbdime/webapp/testnotebooks/base.ipynb /usr/lib/python3.12/site-packages/nbdime/tests/files/multi_cell_nb.ipynb
Could you fix that?

5) Does it have any sense to list graphic files under the BSD license as in "_static/plus.png: BSD-2-Clause"? I think it's only for source code and at https://docs.fedoraproject.org/en-US/legal/allowed-licenses/#_allowed_content_licenses it isn't listed for graphic files.

6) Why giving executable bits to these files? Other py files don't have them.

# Add missing executable bits
chmod a+x \
  %{buildroot}%{python3_sitelib}/nbdime/tests/filters/add_helper.py \
  %{buildroot}%{python3_sitelib}/nbdime/tests/filters/noop.py \
  %{buildroot}%{python3_sitelib}/nbdime/tests/filters/strip_outputs.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/git/diffdriver.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/git/difftool.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/git/mergedriver.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/git/mergetool.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/diff.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/diffweb.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/merge.py \
  %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/mergeweb.py \
  %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdifftool.py \
  %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdiffweb.py \
  %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdimeserver.py \
  %{buildroot}%{python3_sitelib}/nbdime/webapp/nbmergetool.py \
  %{buildroot}%{python3_sitelib}/nbdime/webapp/nbmergeweb.py

7) No difference between following two entries intended?
makehelp nbmerge 'Merge two Jupyter notebooks'
makehelp nbmerge-web 'Merge two Jupyter notebooks'

8) Could you double check that you need it? The subsequent py3_shebang_fix removes "/usr/bin/env" as described at
https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#py3_shebang_fix in my case.

# Remove useless shebangs
sed -i '\,#!/usr/bin/env,d' \
  nbdime/diffing/directorydiff.py \
  nbdime/gitfiles.py \
  nbdime/webapp/nb_server_extension.py \
  nbdime/webapp/webutil.py

9) How do you know which npms you have to bundle? There are many more of them in your vendored packages.

Comment 5 Jerry James 2024-06-18 22:10:41 UTC
Now that the packages needed by python-nbdime have all been built for python 3.13, builds work in Rawhide again.  I have updated the package according to your remarks.  Detailed comments below.

(In reply to wojnilowicz from comment #3)
> 1) Previous post from Fedora Review Service says it doesn't build. Could you
> fix that? I'm not sure if that's related, but it asked me three times about
> various missing dependencies when I tried to build it myself.

I will ask it for a new build momentarily.

> 2) Could you use 
> https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-
> jupytext.spec#_52
> https://src.fedoraproject.org/rpms/python-jupytext/blob/rawhide/f/python-
> jupytext.spec#_144
> instead of
> "# Move the configuration files to where we want them"?

Done.

> 3) rpmlint reported python3-nbdime.noarch: W: no-manual-page-for-binary
> nbdime. Could you fix that?

Done.

> 4) rpmlint reported python3-nbdime.noarch: W: files-duplicate
> /usr/lib/python3.12/site-packages/nbdime/webapp/testnotebooks/base.ipynb
> /usr/lib/python3.12/site-packages/nbdime/tests/files/multi_cell_nb.ipynb
> Could you fix that?

Done.  Now rpmlint complains about a cross-directory hardlink, but since both are under %{python3_sitelib}/nbdime, I don't see that as a problem.

> 5) Does it have any sense to list graphic files under the BSD license as in
> "_static/plus.png: BSD-2-Clause"? I think it's only for source code and at
> https://docs.fedoraproject.org/en-US/legal/allowed-licenses/
> #_allowed_content_licenses it isn't listed for graphic files.

I had a conversation with Richard Fontana once in which I asked him about licenses attached to graphics and font files.  He said that he wished packagers would include those licenses in the License field.  In the case of plus.png, that file is copied from the python3-sphinx package.  The sphinx project is distributed under the BSD-2-Clause license, and does not make any exceptions for the graphic files, so they are implicitly under this license as well.

I recognize that most packagers don't analyze package licenses to this level of detail, but I think it is the right thing to do.  I have been tracking where documentation generators copy files from on this web page: https://jamezone.org/pleasure/software/Fedora/license/.  It is incomplete, but covers the documentation generators my packages use.

> 6) Why giving executable bits to these files? Other py files don't have them.
> 
> # Add missing executable bits
> chmod a+x \
>   %{buildroot}%{python3_sitelib}/nbdime/tests/filters/add_helper.py \
>   %{buildroot}%{python3_sitelib}/nbdime/tests/filters/noop.py \
>   %{buildroot}%{python3_sitelib}/nbdime/tests/filters/strip_outputs.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/git/diffdriver.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/git/difftool.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/git/mergedriver.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/git/mergetool.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/diff.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/diffweb.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/merge.py \
>   %{buildroot}%{python3_sitelib}/nbdime/vcs/hg/mergeweb.py \
>   %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdifftool.py \
>   %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdiffweb.py \
>   %{buildroot}%{python3_sitelib}/nbdime/webapp/nbdimeserver.py \
>   %{buildroot}%{python3_sitelib}/nbdime/webapp/nbmergetool.py \
>   %{buildroot}%{python3_sitelib}/nbdime/webapp/nbmergeweb.py

Because they have shebangs and main functions, indicating they are meant to be executed.

> 7) No difference between following two entries intended?
> makehelp nbmerge 'Merge two Jupyter notebooks'
> makehelp nbmerge-web 'Merge two Jupyter notebooks'

Yes.  I'm not sure what else to write there.  I'm open to suggestions.

> 8) Could you double check that you need it? The subsequent py3_shebang_fix
> removes "/usr/bin/env" as described at
> https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/
> #py3_shebang_fix in my case.
> 
> # Remove useless shebangs
> sed -i '\,#!/usr/bin/env,d' \
>   nbdime/diffing/directorydiff.py \
>   nbdime/gitfiles.py \
>   nbdime/webapp/nb_server_extension.py \
>   nbdime/webapp/webutil.py

The subsequent py3_shebang_fix does remove env, but replaces it with a different shebang.  These files should not have shebangs at all, because they have no main function.

> 9) How do you know which npms you have to bundle? There are many more of
> them in your vendored packages.

You are right.  My analysis was incomplete.  I have now looked at every *.js file in the binary package and determined its origin.  The list of bundled provides is a lot longer.  I'm going to have to write some kind of script to maintain that list.

I have uploaded a new spec file and new source RPM at the URLs in comment 4 (thanks, Bob!).

Comment 6 Jerry James 2024-06-18 22:11:11 UTC
[fedora-review-service-build]

Comment 7 Fedora Review Service 2024-06-18 22:39:33 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7625943
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2278422-python-nbdime/fedora-rawhide-x86_64/07625943-python-nbdime/fedora-review/review.txt

Found issues:

- License file 809.nbdime.js.LICENSE.txt is not marked as %license
  Read more: https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/#_license_text

Please know that there can be false-positives.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 8 wojnilowicz 2024-06-19 18:20:30 UTC
The spec file is big, so there are some issues for sure, but I cannot find anymore, so it LGTM. The package is APPROVED. Thanks for explaining the raised issues.

BTW, before writing the part under "# These two files are identical", you did know the %fdupes macro, right? It takes all the thinking from you.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- rpmlint reports "python-nbdime.spec: W: invalid-url Source1: nbdime-4.0.1-vendor.tar.xz" but I don't see anything wrong with it. It's self-prepared, and not downloaded, and unpacks properly.

- rpmlint reports "python3-nbdime.noarch: W: cross-directory-hard-link /usr/lib/python3.13/site-packages/nbdime/webapp/testnotebooks/base.ipynb /usr/lib/python3.13/site-packages/nbdime/tests/files/multi_cell_nb.ipynb"
but I don't see it as an issue because those files are under application's common directory named nbdime.

- review.txt mentions several "Creative Commons" licenses that are not listed in the spec file, but I also don't see any file in the binary rpm that it should be assigned to, so I guess it's OK.

===== MUST items =====

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-Clause License", "*No copyright*
     BSD 3-Clause License", "ISC License and/or MIT License", "*No
     copyright* ISC License", "MIT License", "*No copyright* MIT License",
     "MIT License [generated file]", "ISC License", "CNRI Python Open
     Source GPL Compatible License Agreement and/or GNU General Public
     License and/or Python License 2.0 and/or Python Software Foundation
     License 2.0", "*No copyright* GNU General Public License", "*No
     copyright* Python License 2.0", "*No copyright* Apache License 2.0",
     "Apache License 2.0", "BSD 3-Clause License and/or ISC License", "BSD
     3-Clause License and/or MIT License", "Creative Commons Attribution
     4.0", "*No copyright* Creative Commons Attribution 4.0", "*No
     copyright* BSD 2-Clause License", "BSD 2-Clause License", "Apache
     License 2.0 and/or Mozilla Public License 1.1", "Academic Free License
     v2.1 and/or BSD 3-Clause License", "*No copyright* Academic Free
     License", "*No copyright* Academic Free License v2.1", "*No copyright*
     Public domain", "MIT License and/or X11 License", "Apache License 2.0
     and/or BSD 0-Clause License and/or BSD 2-Clause License and/or BSD
     3-Clause License and/or ISC License and/or MIT License", "Apache
     License 2.0 and/or BSD 2-Clause License", "BSD 2-clause FreeBSD
     License", "Creative Commons Attribution 3.0", "*No copyright* Creative
     Commons Attribution 3.0", "*No copyright* BSD 2-Clause License and/or
     BSD 3-Clause License and/or GNU Lesser General Public License, Version
     2.1 and/or MIT License", "*No copyright* Creative Commons CC0 1.0",
     "*No copyright* BSD 3-Clause Clear License", "Apache License 2.0
     and/or MIT License", "BSD 0-Clause License", "*No copyright* BSD
     0-Clause License", "*No copyright* The Unlicense", "BSD 2-Clause with
     views sentence", "*No copyright* GNU Lesser General Public License",
     "*No copyright* GNU Library General Public License, Version 2.0", "*No
     copyright* Apache License 2.0 and/or MIT License", "Apache License 2.0
     and/or BSD 3-Clause License", "BSD 3-Clause License [generated file]",
     "Apache License 2.0 and/or BSD 0-Clause License and/or BSD 2-Clause
     License and/or BSD 3-Clause License and/or ISC License and/or MIT
     License and/or zlib License [generated file]", "GNU Library General
     Public License v2 or later". 41592 files have unknown license.
     Detailed output of licensecheck in /var/lib/copr-
     rpmbuild/results/python-nbdime/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /etc/jupyter/jupyter_notebook_config.d,
     /etc/jupyter/nbconfig, /usr/share/licenses, /usr/share,
     /etc/jupyter/nbconfig/notebook.d, /usr/share/man, /usr/lib,
     /usr/lib/python3.13, /usr, /usr/share/jupyter/nbextensions,
     /etc/jupyter, /etc, /etc/jupyter/jupyter_server_config.d,
     /usr/share/doc, /usr/lib/python3.13/site-packages, /usr/bin,
     /usr/share/jupyter/labextensions, /usr/share/jupyter,
     /usr/share/man/man1
[x]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /etc/jupyter/jupyter_notebook_config.d, /etc/jupyter/nbconfig,
     /usr/share/licenses, /usr/share, /etc/jupyter/nbconfig/notebook.d,
     /usr/share/man, /usr/lib, /usr/lib/python3.13, /usr,
     /usr/share/jupyter/nbextensions, /etc/jupyter, /etc,
     /etc/jupyter/jupyter_server_config.d, /usr/share/doc,
     /usr/lib/python3.13/site-packages, /usr/bin,
     /usr/share/jupyter/labextensions, /usr/share/jupyter,
     /usr/share/man/man1
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 16252 bytes in 2 files.
[z]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: The License field must be a valid SPDX expression.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-nbdime
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Checking: python3-nbdime-4.0.1-1.fc41.noarch.rpm
          python-nbdime-doc-4.0.1-1.fc41.noarch.rpm
          python-nbdime-4.0.1-1.fc41.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp209hyp5_')]
checks: 32, packages: 3

python-nbdime.src: E: spelling-error ('nbdiff', '%description -l en_US nbdiff -> diff')
python-nbdime.src: E: spelling-error ('nbmerge', '%description -l en_US nbmerge -> merger, merge')
python-nbdime.src: E: spelling-error ('nbshow', '%description -l en_US nbshow -> shown')
python3-nbdime.noarch: W: python-leftover-require python-jupyter-filesystem
python-nbdime.spec: W: invalid-url Source1: nbdime-4.0.1-vendor.tar.xz
python3-nbdime.noarch: W: cross-directory-hard-link /usr/lib/python3.13/site-packages/nbdime/webapp/testnotebooks/base.ipynb /usr/lib/python3.13/site-packages/nbdime/tests/files/multi_cell_nb.ipynb
 3 packages and 0 specfiles checked; 3 errors, 3 warnings, 19 filtered, 3 badness; has taken 1.4 s 




Rpmlint (installed packages)
----------------------------
(none): E: there is no installed rpm "python3-nbdime".
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.13/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 2

 0 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 filtered, 0 badness; has taken 0.0 s 
(none): E: there is no installed rpm "python-nbdime-doc".
There are no files to process nor additional arguments.
Nothing to do, aborting.



Source checksums
----------------
https://github.com/jupyter/nbdime/archive/4.0.1/nbdime-4.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : e211c7ccc3e4e3026306efa3c1283326b08a0958ec0e2b894a95606bfaed8982
  CHECKSUM(SHA256) upstream package : e211c7ccc3e4e3026306efa3c1283326b08a0958ec0e2b894a95606bfaed8982


Requires
--------
python3-nbdime (rpmlib, GLIBC filtered):
    ((python3.13dist(gitpython) < 2.1.4 or python3.13dist(gitpython) > 2.1.4) with (python3.13dist(gitpython) < 2.1.5 or python3.13dist(gitpython) > 2.1.5) with (python3.13dist(gitpython) < 2.1.6 or python3.13dist(gitpython) > 2.1.6))
    /usr/bin/python3
    config(python3-nbdime)
    fontawesome-fonts-web
    python(abi)
    python-jupyter-filesystem
    python3.13dist(colorama)
    python3.13dist(jinja2)
    python3.13dist(jupyter-server)
    python3.13dist(nbformat)
    python3.13dist(pygments)
    python3.13dist(requests)
    python3.13dist(tornado)

python-nbdime-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-nbdime:
    bundled(npm(@codemirror/autocomplete))
    bundled(npm(@codemirror/commands))
    bundled(npm(@codemirror/lang-cpp))
    bundled(npm(@codemirror/lang-css))
    bundled(npm(@codemirror/lang-html))
    bundled(npm(@codemirror/lang-java))
    bundled(npm(@codemirror/lang-javascript))
    bundled(npm(@codemirror/lang-json))
    bundled(npm(@codemirror/lang-markdown))
    bundled(npm(@codemirror/lang-php))
    bundled(npm(@codemirror/lang-python))
    bundled(npm(@codemirror/lang-rust))
    bundled(npm(@codemirror/lang-sql))
    bundled(npm(@codemirror/lang-wast))
    bundled(npm(@codemirror/lang-xml))
    bundled(npm(@codemirror/language))
    bundled(npm(@codemirror/legacy-modes))
    bundled(npm(@codemirror/search))
    bundled(npm(@codemirror/state))
    bundled(npm(@codemirror/view))
    bundled(npm(@jupyterlab/apputils))
    bundled(npm(@jupyterlab/cells))
    bundled(npm(@jupyterlab/codeeditor))
    bundled(npm(@jupyterlab/codemirror))
    bundled(npm(@jupyterlab/coreutils))
    bundled(npm(@jupyterlab/docregistry))
    bundled(npm(@jupyterlab/documentsearch))
    bundled(npm(@jupyterlab/filebrowser))
    bundled(npm(@jupyterlab/mathjax-extension))
    bundled(npm(@jupyterlab/nbformat))
    bundled(npm(@jupyterlab/notebook))
    bundled(npm(@jupyterlab/observables))
    bundled(npm(@jupyterlab/outputarea))
    bundled(npm(@jupyterlab/rendermime))
    bundled(npm(@jupyterlab/services))
    bundled(npm(@jupyterlab/statedb))
    bundled(npm(@jupyterlab/statusbar))
    bundled(npm(@jupyterlab/theme-light-extension))
    bundled(npm(@jupyterlab/toc))
    bundled(npm(@jupyterlab/translation))
    bundled(npm(@jupyterlab/ui-components))
    bundled(npm(@lezer/common))
    bundled(npm(@lezer/cpp))
    bundled(npm(@lezer/css))
    bundled(npm(@lezer/generator))
    bundled(npm(@lezer/highlight))
    bundled(npm(@lezer/html))
    bundled(npm(@lezer/java))
    bundled(npm(@lezer/javascript))
    bundled(npm(@lezer/json))
    bundled(npm(@lezer/lr))
    bundled(npm(@lezer/markdown))
    bundled(npm(@lezer/python))
    bundled(npm(@lezer/rust))
    bundled(npm(@lezer/xml))
    bundled(npm(@lumino/algorithm))
    bundled(npm(@lumino/collections))
    bundled(npm(@lumino/commands))
    bundled(npm(@lumino/coreutils))
    bundled(npm(@lumino/disposable))
    bundled(npm(@lumino/domutils))
    bundled(npm(@lumino/dragdrop))
    bundled(npm(@lumino/keyboard))
    bundled(npm(@lumino/messaging))
    bundled(npm(@lumino/polling))
    bundled(npm(@lumino/properties))
    bundled(npm(@lumino/signaling))
    bundled(npm(@lumino/virtualdom))
    bundled(npm(@lumino/widgets))
    bundled(npm(alertify.js))
    bundled(npm(call-bind))
    bundled(npm(crelt))
    bundled(npm(css-loader))
    bundled(npm(deepmerge))
    bundled(npm(define-data-property))
    bundled(npm(dom-serializer))
    bundled(npm(domelementtype))
    bundled(npm(domhandler))
    bundled(npm(domutils))
    bundled(npm(entities))
    bundled(npm(es-define-property))
    bundled(npm(es-errors))
    bundled(npm(file-saver))
    bundled(npm(function-bind))
    bundled(npm(get-intrinsic))
    bundled(npm(gopd))
    bundled(npm(has-property-descriptors))
    bundled(npm(has-proto))
    bundled(npm(has-symbols))
    bundled(npm(hasown))
    bundled(npm(htmlparser2))
    bundled(npm(is-plain-object))
    bundled(npm(isarray))
    bundled(npm(json-stable-stringify))
    bundled(npm(jsonify))
    bundled(npm(lib0))
    bundled(npm(lodash.escape))
    bundled(npm(mathjax-full))
    bundled(npm(minimist))
    bundled(npm(nanoid))
    bundled(npm(object-keys))
    bundled(npm(parse-srcset))
    bundled(npm(path-browserify))
    bundled(npm(picocolors))
    bundled(npm(postcss))
    bundled(npm(process))
    bundled(npm(querystringify))
    bundled(npm(requires-port))
    bundled(npm(sanitize-html))
    bundled(npm(set-function-length))
    bundled(npm(style-loader))
    bundled(npm(style-mod))
    bundled(npm(url-parse))
    bundled(npm(w3c-keyname))
    bundled(npm(y-protocols))
    bundled(npm(yjs))
    config(python3-nbdime)
    npm(nbdime)
    python-nbdime
    python3-nbdime
    python3.13-nbdime
    python3.13dist(nbdime)
    python3dist(nbdime)

python-nbdime-doc:
    python-nbdime-doc



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/bin/fedora-review --no-colors --prebuilt --rpm-spec --name python-nbdime --mock-config /var/lib/copr-rpmbuild/results/configs/child.cfg
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Python, Generic
Disabled plugins: SugarActivity, Java, Perl, C/C++, fonts, PHP, R, Haskell, Ocaml
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 9 Jerry James 2024-06-20 20:10:06 UTC
(In reply to wojnilowicz from comment #8)
> The spec file is big, so there are some issues for sure, but I cannot find
> anymore, so it LGTM. The package is APPROVED. Thanks for explaining the
> raised issues.

Thank you for sticking with me through this ordeal.  Whew!

> BTW, before writing the part under "# These two files are identical", you
> did know the %fdupes macro, right? It takes all the thinking from you.

Yes, but in this case it wasn't clear to me which one should be the symlink and which the real file, so I punted and hardlinked them. :-)

> - rpmlint reports "python-nbdime.spec: W: invalid-url Source1:
> nbdime-4.0.1-vendor.tar.xz" but I don't see anything wrong with it. It's
> self-prepared, and not downloaded, and unpacks properly.

That just means that the name is not a resolvable URL, like https://something.  This warning is always issued for files prepared by the packager, rather than downloaded from somewhere.

> - rpmlint reports "python3-nbdime.noarch: W: cross-directory-hard-link
> /usr/lib/python3.13/site-packages/nbdime/webapp/testnotebooks/base.ipynb
> /usr/lib/python3.13/site-packages/nbdime/tests/files/multi_cell_nb.ipynb"
> but I don't see it as an issue because those files are under application's
> common directory named nbdime.

Agreed.

> - review.txt mentions several "Creative Commons" licenses that are not
> listed in the spec file, but I also don't see any file in the binary rpm
> that it should be assigned to, so I guess it's OK.

Yes, more JavaScript is needed at build time than is bundled into the final binary RPM.

Thank you for the review!

Comment 10 Fedora Admin user for bugzilla script actions 2024-06-20 20:13:33 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-nbdime

Comment 11 Fedora Update System 2024-06-20 21:32:48 UTC
FEDORA-2024-ae91d2d2ca (python-nbdime-4.0.1-1.fc40) has been submitted as an update to Fedora 40.
https://bodhi.fedoraproject.org/updates/FEDORA-2024-ae91d2d2ca

Comment 12 Fedora Update System 2024-06-21 02:39:43 UTC
FEDORA-2024-ae91d2d2ca has been pushed to the Fedora 40 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2024-ae91d2d2ca \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2024-ae91d2d2ca

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 wojnilowicz 2024-06-21 19:22:50 UTC
(In reply to Jerry James from comment #9)
> (In reply to wojnilowicz from comment #8)
> > The spec file is big, so there are some issues for sure, but I cannot find
> > anymore, so it LGTM. The package is APPROVED. Thanks for explaining the
> > raised issues.
> 
> Thank you for sticking with me through this ordeal.  Whew!

No problem :)

> > BTW, before writing the part under "# These two files are identical", you
> > did know the %fdupes macro, right? It takes all the thinking from you.
> 
> Yes, but in this case it wasn't clear to me which one should be the symlink
> and which the real file, so I punted and hardlinked them. :-)

Wouldn't a simple "%fdupes %{buildroot}%{python3_sitelib}/nbdime" create a hardlink in your case too?
That's what I see in my nodejs-aw-webui case.

%fdupes reference at https://src.fedoraproject.org/rpms/fdupes/blob/rawhide/f/macros.fdupes

Comment 14 Jerry James 2024-06-25 03:12:22 UTC
Huh.  Somehow I had the idea in my head that %fdupes only symlinked.  You're right, though, it does exactly what I want.  I will make that change for the next build of the package.  Thank you!

Comment 15 Fedora Update System 2024-06-29 01:35:23 UTC
FEDORA-2024-ae91d2d2ca (python-nbdime-4.0.1-1.fc40) has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.